"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function defaultInitial(instance) {
  var className = instance.props.className;
  return _react.default.createElement('span', {
    className: "".concat(className ? "".concat(className, " ") : '', "react-vue-like-async-placeholder")
  });
}

var ReactVueLikeAsync =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ReactVueLikeAsync, _React$Component);

  function ReactVueLikeAsync(props) {
    var _this;

    _classCallCheck(this, ReactVueLikeAsync);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ReactVueLikeAsync).call(this, props));
    _this.mounted = false;
    _this.counter = 0;
    _this.state = {
      error: null,
      result: props.initial || null,
      pending: null,
      isResolved: false
    };
    return _this;
  }

  _createClass(ReactVueLikeAsync, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted = true;
      if (this.props.promise) this.start();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      var promise = this.props.promise;

      if (promise !== prevProps.promise) {
        return promise ? this.start() : null;
      }

      ['initial', 'error', 'loading'].some(function (key) {
        var current = _this2.props[key];

        if (prevProps[key] !== current && _this2.state.result === current) {
          _this2.setState({
            result: current
          });

          return true;
        }
      });
    }
  }, {
    key: "start",
    value: function start() {
      var _this3 = this;

      var _this$props = this.props,
          promise = _this$props.promise,
          initial = _this$props.initial,
          loading = _this$props.loading,
          error = _this$props.error;
      var counter = ++this.counter;

      var isCanceled = function isCanceled() {
        return _this3.state.pending !== promise || !_this3.mounted || counter !== _this3.counter;
      };

      var asyncs = promise && promise.asyncs;

      if (asyncs) {
        if (asyncs.initial !== undefined) initial = asyncs.initial;
        if (asyncs.loading !== undefined) loading = asyncs.loading;
        if (asyncs.error !== undefined) error = asyncs.error;
      }

      if (promise instanceof Promise) {
        this.setState({
          isResolved: false,
          pending: promise,
          result: loading || initial || null,
          error: null
        });

        if (promise) {
          ((0, _utils.isFunction)(promise) ? promise : function () {
            return promise;
          })(this).then(function (result) {
            if (isCanceled()) return;

            _this3.setState({
              isResolved: true,
              result: result,
              pending: null
            });
          }).catch(function (ex) {
            if (isCanceled()) return;

            _this3.setState({
              isResolved: true,
              error: ex,
              result: error || null,
              pending: null
            });
          });
        }
      } else this.setState({
        isResolved: true,
        result: promise,
        pending: null
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "render",
    value: function render() {
      var result = this.state.result;
      if (result && result.__esModule) result = result.default;
      if ((0, _utils.isFunction)(result)) result = result(this);
      return result;
    }
  }]);

  return ReactVueLikeAsync;
}(_react.default.Component);

_defineProperty(ReactVueLikeAsync, "propTypes", {
  className: _propTypes.default.any,
  promise: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.instanceOf(Promise)]).isRequired,
  initial: _propTypes.default.any,
  error: _propTypes.default.any,
  loading: _propTypes.default.any
});

_defineProperty(ReactVueLikeAsync, "defaultProps", {
  initial: defaultInitial
});

(0, _utils.appendProperty)(ReactVueLikeAsync, '__vuelikeAsyncClass', true);
var _default = ReactVueLikeAsync;
exports.default = _default;